<template>
    <div
        v-if="users"
        class="page-container"
    >
        <div class="row">
            <div class="shop-title col-4">
                Users
            </div>
            <div class="col-8 float">
                <div class="float-right">
                    <router-link
                        :to="{name: 'admin-user-create'}"
                        class="btn btn-primary table-btn"
                    >
                        <i class="fa fa-plus" />
                        Create
                    </router-link>
                </div>
            </div>
        </div>
        <div class="table-responsive">
            <table class="table-hover">
                <thead class="table-header">
                    <tr>
                        <th class="reminders-text">
                            User ID
                        </th>
                        <th>Name</th>
                        <th>Email</th>
                        <th>Role</th>
                        <th>Platform</th>
                        <th>Created At</th>
                        <th>Actions</th>
                    </tr>
                </thead>
                <tbody class="table-body">
                    <tr
                        v-for="(user, index) in users"
                        :key="index"
                        class="table-body-row"
                    >
                        <th class="first-column">
                            <div class="first-column">
                                {{ user.id }}
                            </div>
                        </th>
                        <th>{{ user.name }}</th>
                        <th>{{ user.email }}</th>
                        <th>
                            <span class="bg-success">{{ user.role_name }}</span>
                        </th>
                        <th>{{ user.platform }}</th>
                        <th>{{ $formatter.dateFormat(user.created_at) }}</th>
                        <th>
                            <div>
                                <router-link
                                    :to="'/admin/' + user.platform + '/users/' + user.id"
                                    class="btn btn-primary table-btn"
                                >
                                    <i class="fa fa-pencil" />
                                    Edit
                                </router-link>
                            </div>
                            <div v-if="user.role.name !== 'admin'">
                                <div
                                    class="btn red-btn table-btn"
                                    @click="deleteUser(user.id, user.platform)"
                                >
                                    <i class="fa fa-trash" />
                                    Delete
                                </div>
                            </div>
                        </th>
                    </tr>
                </tbody>
            </table>
            <!-- <paginate
                v-if="pageCount > 1"
                v-model="pageNumber"
                :page-count="pageCount"
                :prev-text="'Previous'"
                :click-handler="loadUsers"
                :next-text="'Next'"
                :container-class="'pagination'"
            /> -->
        </div>
    </div>
</template>

<script>
import adminUsers from '@/mixins/admin/users.service'

export default {
    name: "AdminUsers",
    mixins: [adminUsers],
    data() {
        return {
            users: null,
            pageNumber: 1,
        }
    },
    // computed: {
    //     pageCount() {
    //         return Math.ceil( this.data.total / this.data.limit)
    //     }
    // },
    created() {
        this.loadData()
    },
    methods: {
        async loadData() {
            const wixUsers     = await this.getWixUsers(this.pageNumber);
            const shopifyUsers = await this.getShopifyUsers(this.pageNumber);
            wixUsers.map((user) => user.platform = 'wix');
            shopifyUsers.map((user) => user.platform = 'shopify');
            this.users = shopifyUsers.concat(wixUsers);
        },
        async deleteUser(id, platform) {
            await this.deleteAdminUser(id, platform).then((res) => {
                this.$notify({
                    type: 'success',
                    title: res.data.message
                });
                this.loadUsers()
            }).catch((error) => {
                console.log(error)
            });
        },
    }
}
</script>

<style scoped lang="scss">
@import "../../../../resources/css/colors";

.table-btn {
    padding: 5px 10px;
    margin-left: 4px;
}

.bg-success {
    background-color: $green;
    padding: 5px 10px;
    color: white;
    border-radius: 5px;
}

.first-column {
    text-align: left;
}

.shop-title {
    font-size: 28px;
    color: $blue-color;
    margin-bottom: 15px;
}
.red-btn {
    padding: 5px 10px;
    margin-left: 4px;
    border-radius: 6px;
    background-color: red;
    color: white;
}
.page-container {
    padding-top: 80px;
}


</style>
